{$mode objfpc}{$R+}{$H+}
uses
  SysUtils, Types;

const
  SZ = 200;
type
  Found = Exception;
var
  map: array [0..SZ+1, 0..SZ+1] of Char;
  vis: array [0..SZ+1, 0..SZ+1] of Boolean;
  sols: array of array of TPoint;
  path: array [0..SZ * SZ] of TPoint;
  W, H: Integer;
  reverse: Boolean;

procedure Dfs(x, y, d: Integer);
var
  pathSize: Integer;
begin
  if (map[y, x] = '.') or vis[y, x] then exit;
  vis[y, x] := true;
  path[d] := Point(x, y);
  if x = W then begin
    pathSize := (d + 1) * SizeOf(path[0]);
    if (sols = nil) or not CompareMem(@path, @sols[High(sols)][0], pathSize) then begin
      SetLength(sols, Length(sols) + 1);
      SetLength(sols[High(sols)], d + 1);
      Move(path, sols[High(sols)][0], pathSize);
      if Length(sols) >= 2 then
        raise Found.Create('');
    end;
  end;
  if reverse then begin
    Dfs(x + 1, y, d + 1); Dfs(x, y + 1, d + 1);
    Dfs(x - 1, y, d + 1); Dfs(x, y - 1, d + 1);
  end
  else begin
    Dfs(x, y - 1, d + 1); Dfs(x - 1, y, d + 1); 
    Dfs(x, y + 1, d + 1); Dfs(x + 1, y, d + 1); 
  end;
end;

var
  i, j: Integer;
  s: String;
begin
  Assign(input, 'input.txt'); Reset(input);
  Assign(output, 'output.txt'); Rewrite(output);
  Readln(H, W);
  FillChar(map, SizeOf(map), '.');
  for i := 1 to H do begin
    Readln(s);
    Move(s[1], map[i][1], W);
  end;

  try
    for i := 1 to H do begin
      FillChar(vis, SizeOf(vis), false);
      reverse := false;
      Dfs(1, i, 0);
      FillChar(vis, SizeOf(vis), false);
      reverse := true;
      Dfs(1, i, 0);
    end;
    if sols = nil then
      Writeln('NO')
    else
      Writeln('YES');
  except on Found do
    Writeln('MULTIPLE');
  end;
  for i := 0 to High(sols) do begin
    Write(Length(sols[i]), '  ');
    for j := 0 to High(sols[i]) do
      with sols[i][j] do Write(y, ' ', x, '  ');
    Writeln;
  end;
end.
