#pragma comment(linker, "/stack:64000000")

#include <cassert>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

typedef vector<pair<int, int> > VPII;

const int maxn = 200;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, -1, 0, 1};

int n, m;
string s[maxn];

int ans_num;
VPII ans[2], cur;
int vis[maxn][maxn], way[maxn][maxn];

void dfs(int i, int j)
{
    if (ans_num) return;
    cur.push_back(make_pair(i, j));
    vis[i][j] = 1;

    if (j == m-1) {
        ans_num = 1;
        ans[0] = cur;
        for (int sc = 0; sc < cur.size(); sc++)
            way[cur[sc].first][cur[sc].second] = 1;
        return;
    }

    for (int d = 0; d < 4; d++) {
        int idx = i + dx[d], idy = j + dy[d];
        if (0 <= idx && idx < n && 0 <= idy && idy < m && s[idx][idy] == '#' && !vis[idx][idy]) {
            dfs(idx, idy);
            if (ans_num) return;
        }
    }
    cur.pop_back();
}

void dfs1(int i, int j, int fi, int fj, int was_off_the_way)
{
    if (ans_num > 1) return;
    cur.push_back(make_pair(i, j));
    if (!way[i][j]) was_off_the_way++;
    vis[i][j] = 1;

    if (j == m-1) {
        if (was_off_the_way || cur.size() != ans[0].size()) {
            ans_num = 2;
            ans[1] = cur;
            return;
        }
    }

    /*
      ,   ,      ,  ,
        ,        
                .
      ,       .
     */
    if (was_off_the_way && way[i][j]) {
        ans_num = 2;
        ans[1] = cur;
        ans[1].pop_back();
        ans[1].insert(ans[1].end(), 
            find(ans[0].begin(), ans[0].end(), make_pair(i, j)), 
            ans[0].end());
        return;
    }

    for (int d = 0; d < 4; d++) {
        int idx = i + dx[d], idy = j + dy[d];
        if (0 <= idx && idx < n && 0 <= idy && idy < m && s[idx][idy] == '#' 
                && (idx != fi || idy != fj)) {
            if (!vis[idx][idy]) {
                dfs1(idx, idy, i, j, was_off_the_way);
                if (ans_num > 1) return;
            } else if (way[idx][idy]) {
                ans_num = 2;
                ans[1].insert(ans[1].end(), 
                    ans[0].begin(), 
                    ++find(ans[0].begin(), ans[0].end(), make_pair(idx, idy)));
                int sc;
                for (sc = cur.size()-1; sc >= 0; sc--) {
                    ans[1].push_back(cur[sc]);
                    if (way[cur[sc].first][cur[sc].second]) break;
                }
                ans[1].insert(ans[1].end(), 
                    ++find(ans[0].begin(), ans[0].end(), ans[1][ans[1].size()-1]),
                    ans[0].end());
                return;
            }
        }
    }
    if (!way[i][j]) was_off_the_way--;
    cur.pop_back();
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int i, j;

    cin >> n >> m;
    assert(2 <= n && n <= maxn);
    assert(2 <= m && m <= maxn);
    for (i = 0; i < n; i++) cin >> s[i];

    for (i = 0; i < n; i++) {
        if (s[i][0] == '#') {
            if (!ans_num) {  
                cur.clear();
                memset(vis, 0, sizeof(vis));
                dfs(i, 0);
            }
            // ,  else
            if (ans_num) {
                cur.clear();
                memset(vis, 0, sizeof(vis));
                dfs1(i, 0, -1, -1, 0);
            }
        }
    }

    switch(ans_num) {
    case 0:
        cout << "NO" << endl;
        break;
    case 1:
        cout << "YES" << endl;
        cout << ans[0].size() << "  "; 
        for (i = 0; i < ans[0].size(); i++)
            cout << ans[0][i].first+1 << " " << ans[0][i].second+1 << "  ";
        cout << endl;
        break;
    case 2:
        cout << "MULTIPLE" << endl;
        for (j = 0; j < 2; j++) {
            cout << ans[j].size() << "  "; 
            for (i = 0; i < ans[j].size(); i++)
                cout << ans[j][i].first+1 << " " << ans[j][i].second+1 << "  ";
            cout << endl;
        }
        break;
    default:
        assert(0);
    }

    fclose(stdin); fclose(stdout);
    return 0;
}
